<template>
  <div>
    <div class="container-fluid">
      <b-row>
        <b-col cols="12" class="d-flex justify-content-between mt-3">
          <!-- filtros aquí -->
          <b-input-group>
            <b-input-group-prepend is-text>
              <b-icon icon="search"></b-icon>
            </b-input-group-prepend>
            <b-form-input
              v-model="search_term"
              type="text"
              debounce="500"
            ></b-form-input>
          </b-input-group>
        </b-col>
      </b-row>
      <b-row>
        <b-col cols="12">
          <b-table
            ref="table_region"
            :fields="fields"
            class="mt-4 table-hover container-lg"
            responsive
            selectable
            stacked="sm"
            :busy.sync="isBusy"
            :sort-by.sync="sortBy"
            :sort-desc.sync="sortDesc"
            no-local-sorting
            :items="tableProvider"
            :current-page="currentPage"
            :per-page="perPage"
            @row-clicked="onRowClicked"
          >
            <template v-slot:cell(group)="data">
              <span
                v-for="(region, index) in recursiveRegionParentName(data.item)"
                :key="index"
              >
                <b-badge
                  v-if="region.level > 1"
                  variant="light"
                  @click.stop="onParentClick(region)"
                >
                  {{ region.name }}
                </b-badge>
              </span>
            </template>
            <template v-slot:cell(name)="data">
              <span
                v-for="(region, index) in recursiveRegionParentName(data.item)"
                :key="index"
              >
                <strong v-if="region.level == 1">
                  {{ region.name }}
                </strong>
              </span>
            </template>
          </b-table>
        </b-col>
      </b-row>
      <b-row>
        <b-col cols="12">
          <b-pagination
            align="center"
            :total-rows="totalRows"
            :per-page="perPage"
            v-model="currentPage"
            class="float-md-right"
          />
        </b-col>
      </b-row>
    </div>
  </div>
</template>

<script>
export default {
  name: "region-list",
  components: {},
  props: {
    preset_filters: {
      type: Object,
      default: undefined
    },
    defaultText: {
      type: String,
      default: undefined
    },
    isBasic: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      filters: {},
      loading: false,
      isBusy: false,
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      sortBy: null,
      sortDesc: false,
      search_term: undefined
    };
  },
  created() {
    this.search_term = this.defaultText;
  },
  computed: {
    fields() {
      return [
        // {
        //   key: "pk",
        //   label: "ID",
        //   sortable: true
        // },
        {
          key: "group",
          label: "Jerarquía",
          sortable: false
        },
        {
          key: "name",
          label: "Lugar",
          sortable: true
        },
        {
          key: "postal_code",
          label: "Código postal",
          sortable: true
        }
      ];
    }
  },
  watch: {
    search_term: function() {
      this.refresh();
    },
    defaultText: function(newValues) {
      this.search_term = newValues;
    }
  },
  mounted() {
    if (this.preset_filters) {
      this.filters = Object.assign({}, this.filters, this.preset_filters);
    }
  },
  methods: {
    recursiveRegionParentName(item) {
      if (!item.parent_object) {
        return [item];
      }
      if (item.parent_object["pk"]) {
        return this.recursiveRegionParentName(item.parent_object).concat([
          item
        ]);
      }
      return [item];
    },
    tableProvider() {
      this.loading = false;
      let offset = 0;
      var filters = {};
      if (this.perPage && this.currentPage) {
        offset = this.perPage * (this.currentPage - 1);
      }
      filters.offset = offset;
      filters.limit = this.perPage;
      if (this.sortBy) {
        filters["ordering"] = this.sortBy;
        if (this.sortDesc) {
          filters["ordering"] = "-" + filters["ordering"];
        }
      }
      filters = Object.assign(filters, this.filters);
      filters = Object.assign(filters, { trigram_search: this.search_term });

      let uri = this.$parseurl(
        "/logistica/middle/person/{person_pk}/region/",
        {
          person_pk: localStorage.getItem("pk_person")
        },
        filters
      );
      if (this.isBasic) {
        uri = this.$parseurl("/logistica/basic/region/", undefined, filters);
      }

      return new Promise((resolve, reject) => {
        this.$fetchget(uri).then(res => {
          res.json().then(data => {
            if (res.ok) {
              const items = data.results;
              this.loading = false;
              this.totalRows = data.count;
              this.$emit("loaded-rows", items);
              resolve(items);
              return items;
            } else {
              // TODO: LANZAR ERROR
              reject("error");
            }
          });
        });
      });
    },
    onParentClick(data) {
      this.$emit("parent-region-click", Object.assign({}, data));
    },
    onRowClicked(data) {
      this.$emit("region-click", Object.assign({}, data));
    },
    refresh() {
      this.$refs.table_region.refresh();
    }
  }
};
</script>
<style></style>
